## clonezilla-live-src-20140805-trusty-i386.ubuntu.tar.gz

=== CMakeLists.txt ===
PROJECT (cdrkit C)
SUBDIRS(include genisoimage wodim libedc libhfs_iso libparanoia icedax libusal librols libunls readom netscsid 3rd-party/dirsplit)
