=== changelog ===
eglibc (2.19-0ubuntu6.1) trusty-security; urgency=medium

  * SECURITY UPDATE: Directory traversal in locale environment handling
    - debian/patches/any/CVE-2014-0475.diff: validate locale names in
      locale/findlocale.c, locale/setlocale.c, added test to
      localedata/tst-setlocale3.c, localedata/Makefile.
    - CVE-2014-0475
  * SECURITY UPDATE: use-after-free via posix_spawn_file_actions_addopen
    failing to copy the path argument
    - debian/patches/any/CVE-2014-4043.diff: properly copy path in
      posix/spawn_faction_addopen.c, posix/spawn_faction_destroy.c,
      posix/spawn_int.h, added test to posix/tst-spawn.c.
    - CVE-2014-4043

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 28 Jul 2014 12:59:23 -0400

eglibc (2.19-0ubuntu6) trusty; urgency=medium

  * debian/patches/arm64/submitted-setcontext.diff: Update to new version
    of Will's setcontext patch to fix sigmask handling bug (LP: #1306829)

 -- Adam Conrad <adconrad@ubuntu.com>  Sat, 12 Apr 2014 01:47:43 -0600

eglibc (2.19-0ubuntu5) trusty; urgency=medium

  * Merge with unreleased 2.19 from Debian experimental, fixing more bugs:
    - Pull in arm64 patches to fix setcontext corruption (LP: #1279620)
    - Apply the IBM 2.19 branch for POWER8 bug fixes and optimizations.
    - Change M_CHECK_ACTION to abort if first MALLOC_CHECK_ bit is set.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 09 Apr 2014 18:27:57 -0600

eglibc (2.19-0ubuntu4) trusty; urgency=low

  * debian/debhelper.in/libc.preinst:
    - do not show glibc/restart-services question when the system
      is uprading via the desktop session (LP: #1298281)

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 09 Apr 2014 11:33:31 +0200

eglibc (2.19-0ubuntu3) trusty; urgency=medium

  * Merge with unreleased 2.19 from Debian experimental, fixing more bugs:
    - Fix bzero/__bzero definition on powerpc/ppc64 with static builds.
    - Enable IFUNC on arm64 builds, now that the toolchain supports it.
    - Revert removal of the XDR currency for installation-locale FTBFS.
    - Pull update from 2.19 branch, fixing bad math in __sin and __cos.
  * debian/sysdeps/{i386,amd64}.mk: Build i386 flavours with -fno-regmove,
    this can be reverted when gcc-4.9 becomes the default distro compiler.
  * debian/*: Drop the redundant libc6-xen packages on i386 (LP: #1271534)

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 09 Mar 2014 12:21:48 -0600

eglibc (2.19-0ubuntu2) trusty; urgency=medium

  * Merge with unreleased 2.19 from Debian experimental, fixing some bugs:
    - debian/patches/any/local-no-malloc-backtrace.diff: Lower the default
      for MALLOC_CHECK_ to 1, and add it to the list of insecure variables
      that can't be set for suid binaries. This allows us to not backtrace
      malloc failures by default (Closes: #739913, LP: #1266492) and skips
      backtrace for suid binaries where an attacker calling into a corrupt
      malloc internal data structure with malloc could lead to Bad Things.
    - Make ldconfig stop operating on the linker entirely, so our packaged
      symlinks take precedence and hack the postinst to skip ldconfig when
      we detect a broken setup that the old ldconfig mangles (LP: #915995)

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 23 Feb 2014 22:39:18 -0700

eglibc (2.19-0ubuntu1) trusty; urgency=medium

  * Merge with unreleased 2.19 from Debian experimental, remaining changes:
    - Drop the Breaks line from libc6, which refers to a Debian transition
    - Remove the libc6 recommends on libc6-i686, which we don't build
    - Enable libc6{,-dev}-armel on armhf and libc6{-dev}-armhf on armel
    - Ship update-locale and validlocale in /usr/sbin in libc-bin
    - Don't build locales or locales-all in Ubuntu, we rely on langpacks
    - Heavily mangle the way we do service restarting on major upgrades
    - Use different MIN_KERNEL_SUPPORTED versions than Debian, due to
      buildd needs.  This should be universally bumped to 2.6.32 once all
      our buildds (including the PPA guests) are running precise kernels
    - Build i386 variants as -march=i686, build amd64 with -O3, and build
      ppc64 variants (both 64-bit and 32-bit) with -O3 -fno-tree-vectorize
    - debian/patches/ubuntu/local-CVE-2012-3406.diff: switch to malloc when
      array grows too large to handle via alloca extension (CVE-2012-3406)
    - Build generic i386/i686 flavour with -mno-tls-direct-seg-refs
  * debian/patches/series.ppc64el: Drop ppc64el patches included upstream.
  * debian/patches/ubuntu/delete-header-pot.diff: Removed, fixed upstream.
  * expected-results-aarch64-linux-gnu-libc: Ignore two new arm64 failures
    for now, so we can get glibc built and test other packages against it.

 -- Adam Conrad <adconrad@ubuntu.com>  Sat, 15 Feb 2014 19:56:22 -0700

eglibc (2.19-0experimental0) UNRELEASED; urgency=medium

  [ Adam Conrad ]
  * New upstream release: version 2.19, orig tarball built at SVN r25252:
    - debian/patches/alpha/local-string-functions.diff: Rebased.
    - debian/patches/any/local-disable-test-tgmath2.diff: Rebased.
    - debian/patches/any/local-localedef-fix-trampoline.diff: Rebased.
    - debian/patches/any/local-no-malloc-backtrace.diff: Rebased.
    - debian/patches/any/submitted-longdouble.diff: Rebased.
    - debian/patches/hurd-i386/local-enable-ldconfig.diff: Rebased.
    - debian/patches/kfreebsd/local-fbtl-depends.diff: Rebased.
    - debian/patches/kfreebsd/local-scripts.diff: Rebased.
    - debian/patches/locale/preprocessor-collate-uli-sucks.diff: Rebased.
    - debian/patches/localedata/fix-lang.diff: Rebased.
    - debian/patches/localedata/locale-en_DK.diff: Rebased.
    - debian/patches/localedata/locale-hsb_DE.diff: Rebased.
    - debian/patches/localedata/locale-ku_TR.diff: Rebased.
    - debian/patches/localedata/locales-fr.diff: Rebased.
    - debian/patches/localedata/sort-UTF8-first.diff: Rebased.
    - debian/patches/powerpc/local-math-logb.diff: Rebased.

