=== debian/changelog ===
dpkg (1.17.5ubuntu5.3) trusty-security; urgency=medium

  * SECURITY UPDATE: arbitrary file modification via dpkg-source
    - scripts/Dpkg/Source/Patch.pm: Use a better regex for patch header
      parsing
    - 5348cbc981a65c3c9b05bb4d13553bda930c2d78
    - CVE-2014-3864
    - CVE-2014-3865

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 09 Jun 2014 12:34:57 -0400

dpkg (1.17.5ubuntu5.2) trusty-security; urgency=medium

  * SECURITY UPDATE: directory traversal in dpkg-source
    - scripts/Dpkg/Source/Patch.pm: outright reject C-style filenames in
      patches
    - a12eb58959d0a10584a428f4a3103a49204c410f
    - CVE-2014-0471

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 01 May 2014 07:59:19 -0400

dpkg (1.17.5ubuntu5.1) trusty-security; urgency=medium

  * SECURITY UPDATE: directory traversal in dpkg-source
    - scripts/Dpkg/Source/Patch.pm: correctly parse C-style diff
      filenames.
    - Patch thanks to Guillem Jover <guillem@debian.org>
    - CVE-2014-0471

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 23 Apr 2014 19:46:35 -0400

dpkg (1.17.5ubuntu5) trusty; urgency=medium

  * Allow -fstack-protector on arm64 now that GCC and glibc support it.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 07 Mar 2014 18:47:57 +0800

dpkg (1.17.5ubuntu4) trusty; urgency=medium

  * Update the ppc64 buildflags vendor overrides for ppc64el instead, and
    make the implementation respect DEB_BUILD_OPTIONS=noopt (LP: #1279128)

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 11 Feb 2014 18:49:27 -0700

dpkg (1.17.5ubuntu3) trusty; urgency=medium

  * Change native source version/format mismatch errors into warnings until
    the dust settles on Debian bug 737634 about revert or override options.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 05 Feb 2014 07:26:29 -0700

dpkg (1.17.5ubuntu2) trusty; urgency=medium

  * Backport patch from 1.17.6 to fix file descriptor leaks (LP: #1270132)

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 17 Jan 2014 11:01:47 -0700

dpkg (1.17.5ubuntu1) trusty; urgency=medium

  * Merge from Debian testing.  Remaining changes:
    - Change the multiarch downgrade version checks in prerm/postrm
      from 1.16.2 to 1.16.0~ to reflect when multiarch landed in Ubuntu.
    - Migrate dpkg multiarch conffile (and other multi-arch-related
      conf settings) to the new DB with dpkg --add-architecture, but
      keep a copy of the old conffile if it was modified.
    - Out of paranoia, keep an option handler for foreign-architecture
      that informs people that they need to scrub their config files
      and upgrade, on the off chance that the above migration fails
      for some reason (this mitigates the chances of leaving users with
      a dpkg that fails to run due to a broken config).
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.  This is useful for tools
      that hide the dpkg terminal by default and use apport for bug
      reporting with the untranslated error message.
    - Apply patch from Steve McIntyre to special-case armhf/armel ELF
      objects in Shlibs/Objdump.pm, so we don't get incorrect deps.
    - lib/dpkg/pkg-spec.c: map unqualified package names of multiarch-same
      packages to the native arch instead of throwing an error, so that we
      don't break on upgrade when there are unqualified names stored in
      dpkg's own trigger database.
    - Add logic to the postinst to `dpkg --add-architecture i386' on new
      installs on amd64, and to also do so on upgrades from pre-conffile
      Ubuntu versions, mimicking our previous behaviour with the conffile.
    - Apply a workaround from mvo to consider RC packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
 
 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 16 Jan 2014 16:41:23 -0700

dpkg (1.17.5) unstable; urgency=low

  [ Guillem Jover ]
  * Switch non-tty output to be line buffered by default, and set it to fully
    buffered only for programs with precious and abundant output, not just
    progress reporting output (i.e. dpkg-query). This was causing out-of-order
    error and debug messages in relation to normal progress reporting, which
    could be very confusing. Regression introduced in dpkg 1.17.2.
  * Fix segfault in update-alternatives when adding or renaming slaves for
    an existing alternative. Regression introduced in dpkg 1.17.2.
    Closes: #731710
  * Fix dpkg-maintscript-helper symlink_to_dir and dir_to_symlink commands:
    - Always run postinst code regardless of prior-version, as the package
      might have been never configured before.
    - Be more strict when checking the expected state of paths.
    - Rename subcommand shell code to check-files-ownership.
    - Change dir_to_symlink switch code to use a staging empty directory,
      to avoid dpkg removing files from other packages, when removing the
      package old files during upgrade.
    - Bump minimal version in man page to 1.17.5.
    Closes: #731730
  * Mention gpg2 too as one of the default sign commands in dpkg-buildpackage.

  [ Updated dpkg translations ]
  * German (Sven Joachim).

  [ Updated scripts translations ]
  * German (Helge Kreutzmann).

  [ Updated manpages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Thu, 12 Dec 2013 08:29:45 +0100

dpkg (1.17.4) unstable; urgency=low

  * Keep the diversions and statoverride database files open during dpkg
    runs, to avoid eager inode number reuse by the filesystem if these files
    get replaced multiple times in maintainer scripts, as we rely on the
    inode numbers being different when checking if the databases need to
    be reloaded. Regression introduced in 1.17.2. Closes: #731524
  * Add debug output to diversions and statoverride database loading code.

