=== debian/watch ===
version=3
http://pogostick.net/~pnh/ntpasswd/editor.html \
 chntpw-source-(.*)\.zip
